#!/bin/sh
#
#
#
# This routine is used as part of the xamime installation procedure

#
#	CHANGES:
#
#	20041121-0038:PLD
#		-Added Joachim's multiple AV installer patches
#
#


# Load the ANSI sequences if required.
. ./ansi.sh

fmode=700
report=install.log
username=root
localdomain=""
sendmailpg=""
xamimedir=""
adminemail=postmaster
xamimecf=xamime.cf
grepflags=""
findflags=""
localdomainfile=localdomains
install_version="1.2.1  2004 pldaniels <pldaniels@pldaniels.com>"



#  Operating Systems
#
_redhat6x=1
_redhat7x=2
_slackware=3
_debian=4
_suse=5
_freebsd=6
_solaris=7
_fedora=8

#  AntiVirus software
#
_av=0
_noav=0
# ----- AVscanner 1 -----
_fprot=1
_fprotlocation=""
_fprotflags=""
# ----- AVscanner 2 -----
_fsav=2
_fsavlocation=""
_fsavflags=""
# ----- AVscanner 3 -----
_sophos=3
_sophoslocation=""
_sophosflags=""
# ----- AVscanner 4 -----
_mcafee=4
_mcafeelocation=""
_mcafeeflags=""
# ----- AVscanner 5 -----
_kaspersky=5
_kasperskylocation=""
_kasperskyflags=""
# ----- AVscanner 6 -----
_nod32=6
_nod32location=""
_nod32flags=""
# ----- AVscanner 7 -----
_inoc=7
_inoclocation=""
_inocflags=""
# ----- AVscanner 8 -----
_bdc=8
_bdclocation=""
_bdcflags=""
# ----- AVscanner 9 -----
_clamav=9
_clamavlocation=""
_clamavflags=""
# ----- AVscanner 10 -----
_hbedv=10
_hbedvlocation=""
_hbedvflags=""

#
# First, let us create some functions which we will use later on to make things easier
# First, let us create some functions which we will use later on to make things easier
# First, let us create some functions which we will use later on to make things easier


# Find SED
# Find SED
# Find SED
#
if [ -e /usr/bin/sed ]
then
	sedpg=/usr/bin/sed
fi

if [ -e /bin/sed ]
then
	sedpg=/bin/sed
fi

if [ -e /usr/local/bin/sed ]
then
	sedpg=/usr/local/bin/sed
fi



# Search/Replace for the xamime.config file
# Search/Replace for the xamime.config file
# Search/Replace for the xamime.config file
#
SR(){
	searchfor=${1}
	replacewith=${2}
	./replaceit --input=xamime.config "$searchfor" "$replacewith"
}


existance=""
TEST_EXISTANCE(){
	lookfor=$1
	printf "Checking for $lookfor..."
	if [ -e $lookfor ]
	then
		printf "exists\n"
		existance=$lookfor
	else
		printf "\nCannot locate '$lookfor', please enter full path for it : "
		read x
		TEST_EXISTANCE $x
	fi
}


DETERMINE_FINDFLAGS(){

	find . -iname dontfindme > /dev/null 2>./inametest
	result=`cat ./inametest | wc -l`
	if [ $result -eq 0 ]
	then
		findflags="-iname"
	else
		findflags="-name"
	fi

	rm ./inametest > /dev/null 2>/dev/null
}


DETERMINE_GREPFLAGS(){

	is_irlallowed=`printf "testing\n" | grep -irl "testing" | wc -l`
	if [ $is_irlallowed -eq 1 ]
	then
		grepflags="-irl"
	else
		grepflags="-il"
	fi
}

DETERMINE_CRON(){

	if [ -e /etc/crontab ]
	then
		crontabfile="/etc/crontab"
	fi

	if [ -e /var/spool/cron/crontabs/root ]
	then
		crontabfile="/var/spool/cron/crontabs/root"
	fi
}


DETERMINE_CF(){

	if [ -e /etc/sendmail.cf ]
	then
		sendmailcf=/etc/sendmail.cf
	fi

	if [ -e /etc/mail/sendmail.cf ]
	then
		sendmailcf=/etc/mail/sendmail.cf
	fi
}



PRESET_OS(){
	groupadd=`which groupadd`
	useradd=`which useradd`
	ldconfig=`which ldconfig`
	libdir="/usr/lib"
	services="/etc/services"
	passwd="/etc/passwd"
	shadown="/etc/shadow"
	group="/etc/group"
	sendmailpg=`which sendmail`
	DETERMINE_GREPFLAGS
	DETERMINE_FINDFLAGS
	DETERMINE_CRON
	DETERMINE_CF

	if [ "a$sendmailcf" = "a" ]; then
		printf "Could not locate sendmail.cf file, aborting.\n"
		exit 1
	fi

	if [ "a$sendmailpg" = "a" ]; then
		printf "Could not locate sendmail binary file, aborting.\n"
		exit 1
	fi

}


DETECT_OS(){

	install_os=$_slackware

	whatos=`uname -s`
	if [ $whatos = "FreeBSD" ]
	then
		install_os=$_freebsd

	elif [ -d /etc/SuSE-release ]
	then
		install_os=$_suse

	elif [ -d /usr/i386-slackware-linux ]
	then
		install_os=$_slackware

	elif [ -f /etc/redhat-release ]
	then
		ver6=`grep "6\." /etc/redhat-release | wc -l`
		ver7=`grep "7\." /etc/redhat-release | wc -l`
		if [ $ver6 -eq 1 ]
		then
			install_os=$_redhat6x
		elif [ $ver7 -eq 1 ]
		then
			install_os=$_redhat7x
		fi

	elif [ -f /etc/debian_version ]
	then
		install_os=$_debian
	fi
}



_ow_always=1
_ow_status=0

ASKOW(){

	source=$1
	owok=0

	if [ -e $xamimedir/$source ]
	then
		printf "\n%20s exists..." $source
		if [ $_ow_status -ne $_ow_always ]
		then
			printf "Overwrite [y/n/a]? "
			read x
			if [ "a$x" = "aa" ]
			then
				_ow_status=$_ow_always
				owok=1
			elif [ "a$x" = "ay" ]
			then
				owok=1
			fi
		else
			owok=1
			printf "   [$don overwriting $doff]"
		fi
	else
		printf "\n%40s installing..." $source
		owok=1
	fi

	if [ $owok -eq 1 ]
	then
		cp $source $xamimedir
		chmod $fmode $xamimedir/$source
		chown $username $xamimedir/$source
	fi

}



ASKAVSCAN(){
        printf "\n${don}Found${doff} $1\n"
        printf "Would you use $1   (Y/n)"
        read x
        if [ "a$x" != "an" ]
        then
                _av_array="$_av_array $2"
        else
                _av_array="$_av_array"
        fi
}
DETECT_AV(){

	_av=$_noav

	# ----- AVscanner 1 -----
	if [ -e /usr/local/f-prot/f-prot ]
	then
		ASKAVSCAN "F-PROT ANTIVIRUS" $_fprot
	fi
	# ----- AVscanner 2 -----
	if [ -e /usr/local/fsav/fsav ]
	then
		ASKAVSCAN "F-Secure Anti-Virus for i386-linux" $_fsav
	fi
	# ----- AVscanner 3 -----
	if [ -e /usr/local/bin/sweep ]
	then
		ASKAVSCAN "Sophos SWEEP virus detection" $_sophos
	fi
	# ----- AVscanner 4 -----
	if [ -e /usr/local/uvscan/uvscan ]
	then
		ASKAVSCAN "McAfee Virus Scan for Linux" $_mcafee
	fi
	# ----- AVscanner 5 -----
	if [ -e /usr/local/avp/avp ]
	then
		ASKAVSCAN "Kaspersky AVP" $_kaspersky
	fi
	# ----- AVscanner 6 -----
	if [ -e /usr/local/nod32/nod32 ]
	then
		ASKAVSCAN "NOD32 Antivirus System for UNIX" $_nod32
	fi
	# ----- AVscanner 7 -----
	if [ -e /usr/local/inoculateit/inocucmd ]
	then
		ASKAVSCAN "InoculateIT UNIX" $_inoc
	fi
	# ----- AVscanner 8 -----
	if [ -e /opt/bdc/bdc ]
	then
		ASKAVSCAN "BitDefender for Linux" $_bdc
	fi
	# ----- AVscanner 9 -----
	if [ -e /usr/local/bin/clamscan ]
	then
		ASKAVSCAN "ClamAV" $_clamav
	fi
	# ----- AVscanner 10 -----
	if [ -e /usr/bin/antivir ]
	then
		ASKAVSCAN "H&BEDV AntiVir" $_hbedv
	fi

	if [ -e /usr/lib/AntiVir/antivir ]
	then
		ASKAVSCAN "H&BEDV AntiVir" $_hbedv
	fi	

}


SETAVDETAILS(){

	for _av in $_av_array ; do
		# ----- AVscanner 1 -----
		if [ $_av -eq $_fprot ]
		then
			_fprotlocation="/usr/local/f-prot/f-prot"
			_fprotflags=" -archive -list -dumb"
		fi
		# ----- AVscanner 2 -----
		if [ $_av -eq $_fsav ]
		then
			_fsavlocation="/usr/local/fsav/fsav"
			_fsavflags=" --archive --list --dumb"
		fi
		# ----- AVscanner 3 -----
		if [ $_av -eq $_sophos ]
		then
			_sophoslocation="/usr/local/bin/sweep"
			_sophosflags=" -archive -all -rec -sc -dn"
		fi
		# ----- AVscanner 4 -----
		if [ $_av -eq $_mcafee ]
		then
			_mcafeelocation="/usr/local/uvscan/uvscan"
			_mcafeeflags=" --secure -rv --summary"
		fi
		# ----- AVscanner 5 -----
		if [ $_av -eq $_kaspersky ]
		then
			_kasperskylocation="/usr/local/avp/avp"
			_kasperskyflags=" -Y"
		fi
		# ----- AVscanner 6 -----
		if [ $_av -eq $_nod32 ]
		then
			_nod32location="/usr/local/nod32/nod32"
			_nod32flags="-s+ -heursafe"
		fi
		# ----- AVscanner 7 -----
		if [ $_av -eq $_inoc ]
		then
			_inoclocation="/usr/local/inoculateit/inocucmd"
			_inocflags="-sec -nex "
		fi
		# ----- AVscanner 8 -----
		if [ $_av -eq $_bdc ]; then
			_bdclocation="/opt/bdc/bdc"
			_bdcflags=" --all "
		fi
		# ----- AVscanner 9 -----
		if [ $_av -eq $_clamav ]; then
			_clamavlocation="/usr/local/bin/clamscan"
			_clamavflags="--disable-summary --stdout --recursive"
		fi
		# ----- AVscanner 10 -----
		if [ $_av -eq $_hbedv ]; then
			_hbedvlocation="/usr/bin/antivir"
			_hbedvflags="-allfiles -s -ra"
		fi
	done
}



DISPLAY_DETAILS(){

	printf "\
	\n\
	Install path    : $dg$xamimedir$doff\n\
	Admin Email     : $dg$adminemail$doff\n\
	\n\
	Local Domain    : $dg$localdomain$doff\n\
	Sendmail        : $dg$sendmailpg$doff\n\
	Sendmail.cf file: $dg$sendmailcf$doff\n\
	crontab file    : $dg$crontabfile$doff\n\
	\n\
	find flags      : $dg$findflags$doff\n\
	grep flags      : $dg$grepflags$doff\n\
	\n\
	ANTI-Spam details\n\
	SPAM filtering : $dg$use_spamfilter$doff\n\
	\n\
	ANTI-Virus details\n"
	# ----- AVscanner 1 -----
	if [ "a$_fprotlocation" != "a" ]
	then
		printf "\
		F-Prot          : $dg$_fprotlocation$doff\n\
		Flags           : $dg$_fprotflags$doff\n"
	fi
	# ----- AVscanner 2 -----
	if [ "a$_fsavlocation" != "a" ]
	then
		printf "\
		F-Secure        : $dg$_fsavlocation$doff\n\
		Flags           : $dg$_fsavflags$doff\n"
	fi
	# ----- AVscanner 3 -----
	if [ "a$_sophoslocation" != "a" ]
	then
		printf "\
		Sophos          : $dg$_sophoslocation$doff\n\
		Flags           : $dg$_sophosflags$doff\n"
	fi
	# ----- AVscanner 4 -----
	if [ "a$_mcafeelocation" != "a" ]
	then
		printf "\
		Mcafee          : $dg$_mcafeelocation$doff\n\
		Flags           : $dg$_mcafeeflags$doff\n"
	fi
	# ----- AVscanner 5 -----
	if [ "a$_kasperskylocation" != "a" ]
	then
		printf "\
		Kaspersky       : $dg$_kasperskylocation$doff\n\
		Flags           : $dg$_kasperskyflags$doff\n"
	fi
	# ----- AVscanner 6 -----
	if [ "a$_nod32location" != "a" ]
	then
		printf "\
		NOD32           : $dg$_nod32location$doff\n\
		Flags           : $dg$_nod32flags$doff\n"
	fi
	# ----- AVscanner 7 -----
	if [ "a$_inoclocation" != "a" ]
	then
		printf "\
		Innoculate      : $dg$_inoclocation$doff\n\
		Flags           : $dg$_inocflags$doff\n"
	fi
	# ----- AVscanner 8 -----
	if [ "a$_bdclocation" != "a" ]; then
		printf "\
		BitDefender     : $dg$_bdclocation$doff\n\
		Flags           : $dg$_bdcflags$doff\n"
	fi
	# ----- AVscanner 9 -----
	if [ "a$_clamavlocation" != "a" ]; then
		printf "\
		ClamAV          : $dg$_clamavlocation$doff\n\
		Flags           : $dg$_clamavflags$doff\n"
	fi
	# ----- AVscanner 10 -----
	if [ "a$_hbedvlocation" != "a" ]; then
		printf "\
		H&BEDV		: $dg$_hbedvlocation$doff\n\
		Flags		: $dg$_hbedvflags$doff\n"
	fi

}





#
#
# COMPILE fixcf, alterMIME and ripMIME
# COMPILE fixcf, alterMIME and ripMIME
# COMPILE fixcf, alterMIME and ripMIME
#
#


printf "\nNow installing ${dr}X${doff}amimeLT\n------------------------------------------------------------\n"
printf "The install script will now build some required binary files\n"
printf "If any errors occur, please check the 'install.log' file\n"
printf "(please note, building of tools such as ripMIME may take a little while)\n\n"
# First off, compile fixcf
# First off, compile fixcf
# First off, compile fixcf
#
printf "${db}FixCF${doff} - Used to modify config files for sendmail... "
cd fixcf_src
make clean >> $report 2>>$report
make fixcf >> $report 2>>$report
if [ $? -ne 0 ]; then
	printf "Error occured building, see install.log\n\n"
	exit 1
fi
cp fixcf ..
cd ..
printf "${don}done.${doff}\n"

printf "${db}uriencode${doff} - Encodes data into URI format..."
cd uriencode_src
make clean all >> $report 2>>$report
if [ $? -ne 0 ]; then
	printf "Error occured building uriencode, see install.log\n\n"
	exit 1
fi
cp uriencode ..
cd ..
printf "${don}done.${doff}\n"


printf "${db}reportgen${doff} - Builds reports from a template... "
cd reportgen_src
make clean all >> $report 2>>$report
if [ $? -ne 0 ]; then
	printf "Error occured building reportgen, see install.log\n\n"
	exit 1
fi
cp reportgen ..
cd ..
printf "${don}done.${doff}\n"




# Then compile/make 'replaceit' (http://pldaniels.org/replaceit)
# Then compile/make 'replaceit' (http://pldaniels.org/replaceit)
# Then compile/make 'replaceit' (http://pldaniels.org/replaceit)
#
printf "${db}replaceIt${doff} - (http://pldaniels.com/replaceit)... "
cd replaceit_src
make clean >> $report 2>>$report
make >> $report
if [ $? -ne 0 ]; then
	printf "Error occured building, see install.log\n\n"
	exit 1
fi
cp replaceit ..
cd ..
printf "${don}done.${doff}\n"


# Then make and install ripMIME
# Then make and install ripMIME
# Then make and install ripMIME
#
printf "${db}ripMIME${doff} - (http://pldaniels.com/ripmime)... "
cd ripmime_src
make clean >> $report 2>>$report
make >> $report
if [ $? -ne 0 ]; then
	printf "Error occured building, see install.log\n\n"
	exit 1
fi
cp ripmime ..
cd ..
printf "${don}done.${doff}\n"




# Then make alterMIME
# Then make alterMIME
# Then make alterMIME
#
printf "${db}alterMIME${doff} - (http://pldaniels.com/altermime)... "
cd altermime_src
make clean >> $report 2>>$report
make >> $report
if [ $? -ne 0 ]; then
	printf "Error occured building, see install.log\n\n"
	exit 1
fi
cp altermime ..
cd ..
printf "${don}done.${doff}\n"

# Then make fsplit
# Then make fsplit
# Then make fsplit
#
printf "${db}fsplit${doff} - Tool to split a path/file pair... "
cd fsplit_src
make clean >> $report
make fsplit >> $report
if [ $? -ne 0 ]; then
	printf "Error occured building, see install.log\n\n"
	exit 1
fi
cp fsplit ..
cd ..
printf "${don}done.${doff}\n"


# Now we make the 'wrappers/mailfeeder' just incase the person
#	wants to install Postfix
#
printf "${db}MailFeeder${doff} - (http://pldaniels.com/mailfeeder)... "
cd mailfeeder_src
make >> $report
if [ $? -ne 0 ]; then
	printf "Error occured building, see install.log\n\n"
	exit 1
fi
cp mailfeeder ..
cd ..

printf "${don}done.${doff}\n"



sleep 3



# START THE USER-INTERACTIVE-INSTALL-----------------------------
# START THE USER-INTERACTIVE-INSTALL-----------------------------
# START THE USER-INTERACTIVE-INSTALL-----------------------------
#
#

# Save our xamime.raw to a safe place...
# cp xamime.raw xamime.raw.safe
#	all the __PARAMS__ are now stored in the xamime.config file
cp xamime.config xamime.config.safe

clear
printf  "$doff\nInstall version : $install_version\n\n\
Welcome to ${dr}X${doff}amimeLT\n\
\n"


printf "Press ENTER/RETURN to commence..."
read x
clear

# clear our log file
echo "" > $report


printf "Determining your Operating system / Distribution..."
DETECT_OS
printf "$don done $doff\n"

printf "Determining various binary and file locations..."
PRESET_OS
printf "$don done $doff\n"

printf "Determining which AntiVirus agent you have (if any)..."
DETECT_AV
printf "$don done $doff\n"

printf "Setting up AntiVirus parameters..."
SETAVDETAILS
printf "$don done $doff\n"


MTA_SENDMAIL_11=1
MTA_POSTFIX=2
mta_to_use=$MTA_SENDMAIL_11
printf "\n\n\
$don MAIL SERVER PROGRAM $doff \n\
---------------------------------\n\
There are many different mail server programs available\n\
on UNIX systems. Currently XamimeLT supports sendmail and\n\
( in part ) Postfix\n\
\n\
Which mail server are you using? :\n\
(1) Sendmail\n\
(2) Postfix (This will require additional manual steps in\n\
order to complete, please see 'INSTALL.postfix')\n\
\n\
Please Choose one ( default = $mta_to_use ) : "
read x
if [ "a$x" != "a" ]
then
	mta_to_use=$x
fi




xamimedir=/usr/local/xamime
printf  "\n\
$don XamimeLT INSTALL PATH $doff \n\
----------------------------------\n\
This is the path under which all XamimeLT related files are installed.\n\
Binaries such as ripMIME, alterMIME, mailfeeder and other such are \n\
also installed into this path ( rather than the /usr/local/bin etc )\n\
\n\
If you wish, you can always sym-link the spool and temporary subdirectories\n\
to alternative paths ( such as /var/xamime/spool ).\n\
\n\
Where would you like xamime installed? [ $don${xamimedir}$doff ] : "
read x
if [ "a$x" != "a" ]
then
	xamimedir=$x
fi



localdomain=localhost
printf "\n\
$don PRIMARY DOMAIN $doff \n\
-----------------------------\n\
This parameter is used to determine if a sender of an email is from your\n\
local domain, mostly this is used to decide if a disclaimer should be\n\
inserted into the email ( if you have requested to use disclaimers )\n\
\n\
What is the primary email domain (ie pldaniels.com) : "
read x
if [ "a$x" != "a" ]
then
	localdomain=$x
fi


printf  "\n\
$don ADMINISTRATOR EMAIL $doff \n\
----------------------------------\n\
When XamimeLT blocks an email, normally it's a good idea to send a\n\
notification off to somebody.  An idea place to send it is an \n\
administration account specifically setup for xamime\n\
\n\
When Emails are blocked, who should receive notification? [$don${adminemail}$doff] : "
read x
if [ "a$x" != "a" ]
then
	adminemail=$x
fi


responsibleperson="${adminemail}@${localdomain}"
printf  "\n\
$don CLIENT QUERY EMAIL ADDRESS $doff \n\
-----------------------------------------\n\
When XamimeLT blocks an email, the client often gets sent\n\
a blocked-email message in its place.  It is a good idea\n\
to provide a contact email address in those blocked-email\n\
reports so that the client can reach a responsable person\n\
who can assist the client in resolving any issues\n\
\n\
Who is responsible for client responses/queries? [$don${responsibleperson}$doff] : "
read x
if [ "a$x" != "a" ]
then
	responsibleperson=$x
fi




printf "\n\
$don USE A DISCLAIMER $doff \n\
-------------------------------\n\
Although the use of a disclaimer appended to the end of the text\n\
body of outgoing emails is a rather wasteful thing, a lot of people\n\
prefer to insert them.  It should be noted that the alterMIME\n\
program responsible for inserting disclaimers will err to the side\n\
of caution when it attempts to insert a disclaimer.  Occasionally\n\
there will be emails which alterMIME simply will not insert\n\
disclaimers into for the reasons of maintaing the stability of\n\
the email's data structure\n\
\n\
The file used to hold the disclaimer text is $xamimedir/disclaimer\n\
\n\
Would you like to use a disclaimer (y/N) : "
read x
if [ "a$x" != "ay" ]
then
	usedisclaimer="n"
else
	usedisclaimer="y"
fi





# Spam filtering question
#
printf "\n\
$don USE SPAM FILTERING $doff \n\
---------------------------------\n\
SPAM is a huge problem on the modern day email system, up to\n\
60%% of emails are attributable to SPAM.  A fantastic package\n\
called SpamAssassin is available and can be used by XamimeLT  to \n\
help filter out a lot of the SPAM. \n\
\n\
XamimeLT uses an external script module called spamc-filter, spam-filter to \n\
invoke and test the email (currently) using SpamAssassin. If you\n\
want to change the 'cutoff' level, then please check in the\n\
'spamfilter' script\n\
\n\
NOTE - you must have SpamAssassin already installed.\n\
\n\
Use SpamAssassin filtering? ( You must have SpamAssassin installed for this ) (Y/n) : "
read x
if [ "a$x" != "an" ]
then
	use_spamfilter="y"
else
	use_spamfilter="n"
fi



clear

printf "\n\n\n\nDetails of your installation...\n"
DISPLAY_DETAILS
printf "Do you wish to install? (Y/n) : "
read x
if [ "a$x" = "an" ]
then
	printf  "\nYou can reinstall simply by typing in ./install.sh again.\n\n\n"
	cp xamime.config.safe xamime.config
	#cp xamime.raw.safe xamime.raw
	exit
fi

clear

printf "${dg}Creating 'xamime' script...${doff}\n"
# Create our local domain file....
#
printf "$localdomain\n" >> $localdomainfile


# Get our system specific binary locations, and insert them into the xamime.config file
# Get our system specific binary locations, and insert them into the xamime.config file
# Get our system specific binary locations, and insert them into the xamime.config file
#
SR __XAMIMEDIR__ $xamimedir
SR __ADMIN_EMAIL__ $adminemail
SR __LOCALDOMAIN__ $localdomain
SR __USEDISCLAIMER__ $usedisclaimer
SR __DISCLAIMER__ $disclaimer
SR __CUT__ `which cut`
SR __TEST__ `which test`
SR __GREP__ `which grep`
SR __FILE__ `which file`
SR __FIND__ `which find`
SR __TOUCH__ `which touch`


if [ $mta_to_use -eq $MTA_SENDMAIL_11 ]
then
	SR __SENDMAIL__ $sendmailpg
	SR __SENDMAIL_CF__ $sendmailcf
	# 1 comes from the xamime.config file, where 1 == SENDMAIL 8.11.x
	SR __MTA_TO_USE__ 1
fi

if [ $mta_to_use -eq $MTA_POSTFIX ]
then
	# 10 comes from the xamime.config file, where 10 == POSTFIX
	SR __MTA_TO_USE__ 10
fi


#SR __RIPMIME__ "./ripmime"
#SR __ALTERMIME__ "./altermime"
SR __GREP_FLAGS__ $grepflags
SR __FIND_FLAGS__ $findflags
SR __USE_SPAMFILTER__ $use_spamfilter

# ----- AVscanner 1 -----
SR __FPROT__ $_fprotlocation
SR __FPROTFLAGS__ ${_fprotflags}
# ----- AVscanner 2 -----
SR __FSAV__ $_fsavlocation
SR __FSAVFLAGS__ ${_fsavflags}
# ----- AVscanner 3 -----
SR __SOPHOS__ $_sophoslocation
SR __SOPHOSFLAGS__ ${_sophosflags}
# ----- AVscanner 4 -----
SR __MCAFEE__ $_mcafeelocation
SR __MCAFEEFLAGS__ ${_mcafeeflags}
# ----- AVscanner 5 -----
SR __KASPERSKY__ $_kasperskylocation
SR __KASPERSKYFLAGS__ ${_kasperskyflags}
# ----- AVscanner 6 -----
SR __NOD32__ $_nod32location
SR __NOD32FLAGS__ ${_nod32flags}
# ----- AVscanner 7 -----
SR __INOC__ $_inoclocation
SR __INOCFLAGS__ ${_inocflags}
# ----- AVscanner 8 -----
SR __BITDEFENDER__ $_bdclocation
SR __BITDEFENDERFLAGS__ ${_bdcflags}
# ----- AVscanner 9 -----
SR __CLAMAV__ $_clamavlocation
SR __CLAMAVFLAGS__ ${_clamavflags}
# ----- AVscanner 10 -----
SR __HBEDV__ $_hbedvlocation
SR __HBEDVGLAGS__ $_hbedvflags

cp xamime.raw xamime


if [ $mta_to_use -eq $MTA_SENDMAIL_11 ]
then

	# Create our xamime.cf file off the existing sendmail.cf
	# Create our xamime.cf file off the existing sendmail.cf
	# Create our xamime.cf file off the existing sendmail.cf
	#

	printf "${dg}Applying updates to sendmail.cf to create xamime.cf...${doff}"
	./adapt-sendmailcf.sh	${sendmailcf}  ${xamimedir}
	if [ $? -ne 0 ]; then
		printf "ERROR: While running ./adapt-sendmailcf.sh, something went wrong\n"
		printf "Terminating this installation\n"
		exit 1
	fi

	printf "$don done.$doff\n"
fi




# Create the directories...
# Create the directories...
# Create the directories...
#
printf "${dg}Creating directories...${doff}\n"
mkdir -p ${xamimedir} >>$report 2>>$report
mkdir -p ${xamimedir}/spool  >>$report 2>>$report
mkdir -p ${xamimedir}/tmp >>$report 2>>$report



# Install our binaries
# Install our binaries
# Install our binaries
#
printf "${dg}Installing binary files...${doff}\n"
fmode=700
for source in xamime xamime-test* uriencode reportgen unarchive.sh xamime-spam* ripmime fsplit mailfeeder altermime; do
	ASKOW $source
done;

printf "\n${dg}Installing report templates...${doff}\n"
fmode=600
for source in [asr]*.report; do
	ASKOW $source
done;

printf "\n${dg}Creating xamime-debug link...${doff}\n"
ln -s ${xamimedir}/xamime ${xamimedir}/xamime-debug

printf "\n${dg}Installing XamimeLT configuration file (xamime.config)... ${doff}\n"
ASKOW xamime.config
mv xamime.config xamime.config-lastinstall
mv xamime.config.safe xamime.config

if [ $mta_to_use -eq $MTA_SENDMAIL_11 ]
then
	ASKOW xamime.cf
fi


# Create a small disclaimer file...
if [ -e $xamimedir/disclaimer ]
then
	# Check to see if the old dislcaimer is the one with pldaniels in it, if so
	# then /REMOVE/ it, because it's causing us a LOT of legal threats!!!!
	ispldaniels=`grep pldaniels $xamimedir/disclaimer | wc -l`
	if [ $ispldaniels -gt 0 ]
	then
		printf "\n\n${dg}Exising disclaimer contains @pldaniels.com info, updating${doff}\n"
		printf "\n______________________________________\nXamimeLT - installed on mailserver for domain @${localdomain}\nQueries to: ${responsibleperson}\n" > $xamimedir/disclaimer
	fi

	printf "\n\n${dg}Disclaimer already exists...not overwriting${doff}\n"

else
	printf "\n______________________________________\nXamimeLT - installed on mailserver for domain @${localdomain}\nQueries to: ${responsibleperson}\n" > $xamimedir/disclaimer
fi

# Set root.root ability of the xamime file
# Set root.root ability of the xamime file
# Set root.root ability of the xamime file
#
chmod a+s ${xamimedir}/xamime >>$report 2>>$report



if [ $mta_to_use -eq $MTA_SENDMAIL_11 ]
then
	# Lets try get our CRON entries in...
	# Lets try get our CRON entries in...
	# Lets try get our CRON entries in...
	#
	printf "\n\n$dg Searching for CRONTAB entries for Sendmail queuing...$doff\n"

	# now lets do the sendmail -q
	#
	#
	cronexists=`grep "sendmail -q" $crontabfile | grep -v grep | wc -l`
	if [ $cronexists -eq 0 ]
	then
		if [ $install_os -eq $_freebsd\
			-o $install_os -eq $_suse\
			-o $install_os -eq $_redhat7x ]
		then
			printf "0,15,30,45	*	*	*	*	root	$sendmailpg -q\n" >> $crontabfile
		else
			printf "0,15,30,45 * * * *	${sendmailpg} -q\n" >> $crontabfile
		fi
		printf "Sendmail queue entry...$don done.$doff\n"
	else
		printf "Sendmail queue entry...already exists, $don skipping update$doff\n"
	fi


	printf "\n\nDo you want to attempt to update your OS startup files\nto make XamimeLT start automatically when you reboot ? (Y/n) : "
	read x
	clear
	if [ "a$x" != "an" ]
	then
		printf "$dg Running Startup Installers...$doff"
		./install-init.sh ${xamimedir}
		sleep 2
		printf "$don done.$doff"
	fi


	#	printf  "\n\
	#Do you want to restart sendmail (Y/n) : "
	#	read x
	#	clear
	#	if [ "a$x" != "an" ]
	#	then
	#		printf "$dg Killing existing sendmail services...$doff"
	#		killall sendmail
	#		sleep 2
	##		printf "$don done.$doff\n$dg Restarting sendmail...$doff"
	#	
	#		${sendmailpg} -bd -q15m -C $xamimedir/$xamimecf
	#		sleep 2
	#		count=`ps -ax | grep sendmail | grep -v grep | wc -l`
	#		if [ $count -gt 0 ]
	#		then
	#			printf  "$don Successfully restarted$doff.\n"
	#		else
	#			printf  "$dr Error - Could not restart$doff.\n"
	#			fi
	#		fi


fi
# END of sendmail specific install bits



if [ $mta_to_use -eq $MTA_POSTFIX ]
then
	printf "\n$don POSTFIX Specific Notes $doff\n------------------------------------\n"

	printf "Adding group and users required for Xamime with Postfix..."
	if [ $install_os -eq $_freebsd ]; then
		pw add user xamime
	else
		groupadd xamime
		useradd -g xamime xamime
	fi
	printf "${dg}done.${doff}\n"

	pfixpath=""
	if [ -e /etc/postfix ]; then
		pfixpath=/etc/postfix
	fi

	if [ -e /usr/local/etc/postfix ]; then
		pfixpath=/usr/local/etc/postfix
	fi

	if [ "x$pfixpath" = "x" ]; then
		printf "ERROR: Cannot find postfix configuration files."
		printf "Please enter the path to find the files (ie, /etc/postfix) : "
		read pfixpath
	fi

	maincf=$pfixpath/main.cf
	if [ -f $maincf ]; then
		printf "Adding content_filter=xamime line to $maincf..."
		grep -q "content_filter=xamime" $maincf
		if [ $? -eq 0 ]; then
			printf "\nXamime content line already exists in $maincf\n"
		else
			printf "content_filter=xamime\n" >> $maincf
			printf "${dg}done.${doff}\n"
		fi
	fi

	mastercf=$pfixpath/master.cf
	if [ -f $mastercf ]; then
		printf "Adding Xamime and localhost agent lines to $mastercf..."
		grep -q "xamime unix" $mastercf
		if [ $? -eq 0 ]; then
			printf "\nXamime transport agent line already exists in $mastercf\n"
		else
			printf "xamime unix -  n n - 10 pipe user=xamime argv=${xamimedir}/xamime ${xamimedir}/xamime.config \${sender} \${recipient}\n" >> $mastercf
		fi

		grep -q "localhost:10025" $mastercf
		if [ $? -eq 0 ]; then
			printf "\nXamime local loopback (port 10025) line already exists in $mastercf\n"
		else
			printf "localhost:10025 inet n - n - - smtpd -o content_filter=\n" >> $mastercf
		fi

		printf "${dg}done.${doff}\n"
	fi

	printf "Changing ownership of Xamime directory to xamime.xamime..."
	chown -R xamime.xamime ${xamimedir} >> /dev/null 2>>/dev/null
	printf "${dg}done.${doff}\n"

	printf "Postfix XamimeLT installation is now complete.\n"
	printf "Please restart Postfix for Xamime to take effect.\n\n"

fi


printf "\n\
__________________________________________________________________\n\
\nCongratulations, XamimeLT is now installed.\n\
\n\
You will now need to restart your mailserver, (Sendmail or Postfix)
to activate Xamime.\n\
\n\
Please edit the 'xamime' shell script in the installation directory\n\
and make sure that you block the filenames/types/text which YOU want\n\
to be blocked.\n\
\n\
The default blockings are very limited and designed purely for example\n\
purposes.\n\
\n\
For further details, visit the XamimeLT WWW site at\n\
http://www.xamime.com/xamimelt\n\
\n\
__________________________________________________________________\n"


#----------------------------------------DONE.


